import { IAction } from './Actions';
export interface IActionReducer<TState, TActionPayload> {
    (state: TState, action: IAction<TActionPayload>): TState;
}
export interface IReduxRetroReducer<TState, TActionPayload> extends IActionReducer<TState, TActionPayload> {
    bindAction: <TNextActionPayload>(action: (...args: any[]) => TNextActionPayload, reducer: IActionReducer<TState, TNextActionPayload>) => IReduxRetroReducer<TState, any>;
}
export interface IPayloadCreator<TPayload> {
    (...args: Object[]): TPayload;
    actionType?: string;
}
export interface IBoundAction<TActionPayload, TState> {
    payloadCreatorMethod: IPayloadCreator<TActionPayload>;
    reducerFunction: IActionReducer<TState, TActionPayload>;
}
export interface IReducerWrapper<TState> {
    reducer: IReduxRetroReducer<TState, any>;
}
export declare const reducer: {
    generateActionBinder<TState>(boundActions: IBoundAction<any, TState>[], mainReducer: IActionReducer<TState, any>): {
        bindAction<TNextActionPayload>(action: IPayloadCreator<TNextActionPayload>, actionReducer: IActionReducer<TState, TNextActionPayload>): IActionReducer<TState, TNextActionPayload>;
    };
    generateReducer<TState>(boundActions: IBoundAction<any, TState>[], initialState: TState): IReduxRetroReducer<TState, any>;
    createReducer<TState>(initialState: TState): IReduxRetroReducer<TState, any>;
};
export declare const createReducer: <TState>(initialState: TState) => IReduxRetroReducer<TState, any>;
